//const int data_out = 2;//encoder DOUT
#include <Wire.h>
 //LED pin,When receiving the key from the serial port, LED flash
const int ledPin =  13;    //LED pin
const int gnd_pin =  9;       //AS GND 
const int data_out =  10;     //encoder DOUT
const int vcc_pin=  11;       //AS VCC
// OSC Resistance is 3.3M
const int Osc_4xCycle = 359; //4 oscillating time periods 
const int Osc_12xCycle = 1078;//12 oscillating time periods
unsigned long Temporary[3];//Temporary storage unit
String CommandString="";
String keydata;
int receive_flag = 0;
char *SplitCommands[20]; // an array of pointers to the pieces of the above array after strtok()

/*------------------------------------------------------------------------------------------------------------*/
//output bit "0"
void bit_0() {
  
  digitalWrite(data_out, HIGH);
  delayMicroseconds(Osc_4xCycle);//4 oscillating time periods High level
  digitalWrite(data_out, LOW);
  delayMicroseconds(Osc_12xCycle);//12 oscillating time periods Low level
  digitalWrite(data_out, HIGH);
  delayMicroseconds(Osc_4xCycle);//4 oscillating time periods High level
  digitalWrite(data_out, LOW);
  delayMicroseconds(Osc_12xCycle);//12 oscillating time periods Low level 
}
/*------------------------------------------------------------------------------------------------------------*/
//output bit "1"
void bit_1() {
  
  digitalWrite(data_out, HIGH);
  delayMicroseconds(Osc_12xCycle);//12 oscillating time periods High level
  digitalWrite(data_out, LOW);
  delayMicroseconds(Osc_4xCycle);//4 oscillating time periods Low level
  digitalWrite(data_out, HIGH);
  delayMicroseconds(Osc_12xCycle);//12 oscillating time periods High level
  digitalWrite(data_out, LOW);
  delayMicroseconds(Osc_4xCycle);//4 oscillating time periods Low level
}
/*------------------------------------------------------------------------------------------------------------*/
//output bit "f"
void bit_f() {
  
  digitalWrite(data_out, HIGH);
  delayMicroseconds(Osc_4xCycle);//4 oscillating time periods High level
  digitalWrite(data_out, LOW);
  delayMicroseconds(Osc_12xCycle);//12 oscillating time periods Low level
  digitalWrite(data_out, HIGH);
  delayMicroseconds(Osc_12xCycle);//12 oscillating time periods High level
  digitalWrite(data_out, LOW);
  delayMicroseconds(Osc_4xCycle);//4 oscillating time periods Low level
}
/*------------------------------------------------------------------------------------------------------------*/
//output synchronous bit
void bit_syn() {
  digitalWrite(data_out, HIGH);
  delayMicroseconds(Osc_4xCycle);//4 oscillating time periods High level
  digitalWrite(data_out, LOW);
  delayMicroseconds(Osc_4xCycle*31);//124 oscillating time periods Low level
}
/*------------------------------------------------------------------------------------------------------------*/
//send:8 Address Bits, 4 Data Bits, Sync bit
void send_data(){
  unsigned char temp,tab,i;
  unsigned char j,k;
  for(j=0;j<4;j++)
  {
    for(k=0;k<3;k++)//send 8 Address Bits, 4 Data Bits
    {
      tab = Temporary[k];
      for(i=0;i<4;i++)
      {
        temp = tab;
        temp &= 0xC0;
      
        if(temp == 0xC0)//11 is bit "1"
        {
          bit_1();

        }
        else if(temp == 0x00)//00 is bit "0"
        {
          bit_0();
        }
        else //01 is bit "f"
        {
          bit_f();
         }
      
        tab =  tab << 2;
    }
  }
   bit_syn();//send Sync bit
  }
}

/*------------------------------------------------------------------------------------------------------------*/
void setup() {
  pinMode(ledPin, OUTPUT);  
  pinMode(data_out, OUTPUT); 
  pinMode(gnd_pin, OUTPUT); 
  pinMode(vcc_pin, OUTPUT);   
  digitalWrite(vcc_pin, HIGH);//SET VCC
  digitalWrite(gnd_pin, LOW);//SET GND 
  Wire.begin(8);                /* join i2c bus with address 8 */
  Wire.onReceive(receiveEvent); /* register receive event */
  Wire.onRequest(requestEvent); /* register request event */
  Serial.begin(9600);           /* start serial for debug */
  Serial.println("Setup Finished !"); 
}
/*------------------------------------------------------------------------------------------------------------*/
void receiveEvent(int howMany) {
 while (0 <Wire.available()) {
    char c = Wire.read();      /* receive byte as a character */
    Serial.print(c);           /* print the character */
    Serial.println();             /* to newline */
    keydata=c;
    receive_flag = 1;
    RunCommandsToAntenna();
  }
}
/*------------------------------------------------------------------------------------------------------------*/
// function that executes whenever data is requested from master
void requestEvent() {
 Wire.write("Got Commands..");  /*send string on request */
}
/*------------------------------------------------------------------------------------------------------------*/
void loop()
{
 delay(111);
}
/*------------------------------------------------------------------------------------------------------------*/
void RunCommandsToAntenna ()
{
  Temporary[0] = 0xC5;//address A7-A4
  Temporary[1] = 0x55;//address A3-A0
  digitalWrite(ledPin, LOW);//Turn off led
    if(receive_flag == 1)//if get key,send key
    {
            Serial.print("Execute Commands : ");
            Serial.print(keydata); 
            Serial.println("<");
            receive_flag = 0;
      
            if((keydata == "a") || (keydata == "A")|| (keydata == "1"))
            {
              Temporary[2] = 0xC3;  //ok 
              digitalWrite(ledPin, HIGH);//Turn on led
              send_data();//send code word
              Serial.println(".....trigger 1 channel relay.....");
              delay(50);
            }
            else if((keydata == "b") || (keydata == "B")|| (keydata == "2"))
            {
              Temporary[2] = 0xB0;  //ok
              digitalWrite(ledPin, HIGH);//Turn on led
              send_data();//send code word
              Serial.println(".....trigger 2 channel relay.....");
              delay(50);
            }
             else if((keydata == "c") || (keydata == "C")|| (keydata == "3"))
             {
              Temporary[2] = 0xC9;  //ok
              digitalWrite(ledPin, HIGH);//Turn on led
              send_data();//send code word
              Serial.println(".....trigger 3 channel relay....."); 
              delay(50);   
             }
             else if((keydata == "d") || (keydata == "D")|| (keydata == "4"))
             {
              Temporary[2] = 0xD0;  //ok
              digitalWrite(ledPin, HIGH);//Turn on led
              send_data();//send code word
              Serial.println(".....trigger 4 channel relay.....");  
              delay(50);  
             }
            else if((keydata == "e") || (keydata == "E")|| (keydata == "5"))
            {
              Temporary[2] = 0xAA; //ok
              digitalWrite(ledPin, HIGH);//Turn on led
              Serial.println(".....trigger 5 channel relay.....");
              send_data();//send code word
              delay(50);
            }
            else if((keydata == "f") || (keydata == "F")|| (keydata == "6"))
            {
              Temporary[2] = 0xD9;  //ok
              digitalWrite(ledPin, HIGH);//Turn on led
              Serial.println(".....trigger 6 channel relay.....");
              send_data();//send code word
              delay(50);
            }
            else if((keydata == "g") || (keydata == "G")|| (keydata == "7"))
            {
              Temporary[2] = 0x27;  //ok
              digitalWrite(ledPin, HIGH);//Turn on led
              Serial.println(".....trigger 7 channel relay.....");
              send_data();//send code word
              delay(50);
            }
            else if((keydata == "h") || (keydata == "H")|| (keydata == "8"))
            {
              Temporary[2] = 0x29;  //ok
              digitalWrite(ledPin, HIGH);//Turn on led
              Serial.println(".....trigger 8 channel relay.....");
              send_data();//send code word
              delay(50);
            }
              else if((keydata == "i") || (keydata == "I")|| (keydata == "9"))
            {
              Temporary[2] = 0x28;
              digitalWrite(ledPin, HIGH);//Turn on led
              Serial.println(".....trigger 9 channel relay.....");
              send_data();//send code word
              delay(50);
            }
    keydata = "";
    digitalWrite(ledPin, LOW);//Turn off led
    delay(5);//delay 100ms
    digitalWrite(ledPin, HIGH);//Turn on led
    delay(5);//delay 100ms
   }
}
